import { HttpService } from '@nestjs/axios';
import { Injectable, Logger } from '@nestjs/common';
import { Cron, CronExpression } from '@nestjs/schedule';
import { firstValueFrom } from 'rxjs';

// * * * * * *
// | | | | | |
// | | | | | day of week
// | | | | months
// | | | day of month
// | | hours
// | minutes
// seconds (optional)

@Injectable()
export class TasksService {
  private readonly logger = new Logger(TasksService.name);

  constructor(private readonly httpService: HttpService) {}

  private async request(link: string) {
    try {
      const response = await firstValueFrom(
        this.httpService.get(`http://localhost:3000/parse?link=${link}`),
      );
      return response.data;
    } catch (e) {
      return 'Error!';
    }
  }

  @Cron('0 */20 * * * *', {
    name: 'sendParse',
    timeZone: 'Europe/Moscow',
    disabled: true,
  })
  async sendParse() {
    const link =
      'https://novex.ru/catalog/product/nabor-polot-c-smart-35-75-70-140-brusn/';
    const res = await this.request(link);
    this.logger.debug(res);
    this.logger.debug('Called when the current second is 10');
  }
}
